<?php
namespace Neuron\Person\Controller;

class Parameter extends \Neuron\Person\Controller {
	protected function getView($name, $variables = array()) {

		/* default layout & view prefix */
		$layout = 'neuron/person/layout/form';
		$prefix = 'neuron/person/parameter';

		/* libraries */
		if(! class_exists('Neuron\Application\Framework\Entity')) {
			$this->using(
				'bootstrap-4',
				null,
				array(
					'https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js',
					'https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js',
					'https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css',
					'https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js'
				)
			);
		}

		/* get layout n view prefix from config */
		$config = $this->getConfig();
		if (isset($config['employee'])) {
			$config = $config['employee'];
			$layout = isset($config['formlayout']) ? $config['formlayout'] : $layout;
			$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		/* set layout and view */
		$libs['Contact'] = class_exists('Neuron\Contact\Controller\Contact');
		$libs['Organization'] = class_exists('Neuron\Organization\Controller\Organization');
		$libs['Payroll'] = class_exists('Neuron\Payroll\Controller\Payroll');
		$variables['libs'] = $libs;

		$this->layout($layout);
		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name));

        // $view->setVariables(array(
        //     'sessmgt' => $this->getSession(),
        // ));

		return $view;
	}

	public function manageAction() {

		$layout = $this->layout();
		// $layout->setVariables(['previous' => '<a href="'.$this->getPublicURL().'/person/index/manage">Manage Parameters</a>']);
		$layout->setVariables(['current' => 'Manage Parameters']);

		$this->getSession();
		$this->using('font-awesome', 10, 'https://use.fontawesome.com/releases/v5.8.1/css/all.css');
		$this->using('datatable', 20, array(
			'https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js',
			'https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap4.min.js',
			'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
		));
		
		$this->usingJs('bootbox',21,  array(
			'https://cdnjs.cloudflare.com/ajax/libs/bootbox.js/4.4.0/bootbox.min.js'
		));
		$this->using('p-loading', 22);
		$this->usingJs('moment', 23, array(
			'https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.29.1/moment.min.js'
		));
		$this->using('air-datepicker', 24, array(
			"https://cdnjs.cloudflare.com/ajax/libs/air-datepicker/2.2.3/js/datepicker.min.js",
			"https://cdnjs.cloudflare.com/ajax/libs/air-datepicker/2.2.3/css/datepicker.min.css",
			"https://cdnjs.cloudflare.com/ajax/libs/air-datepicker/2.2.3/js/i18n/datepicker.en.min.js"

		));
		// $this->using('bootstrap-datepicker', 24);
		$this->using('bootstrap-imageupload', 25);
		$this->using('select2', 22, array(
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/select2.min.js',
			 /* ini load sesuai bahasa dari session */
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/js/i18n/id.js',
			 /**/
			'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.10/css/select2.min.css',
			'https://cdn.jsdelivr.net/npm/@ttskch/select2-bootstrap4-theme@1.3.2/dist/select2-bootstrap4.min.css',
		));		
		$this->using('jquery.validate',33);

		$this->using('nAlert',999999);

		return $this->getView('manage', get_defined_vars());
	}

	public function listAction() {
		$storage = \Neuron\Person\Parameter\Storage::factory($this->getDb(), $this->getConfig());
		$cpar = new \Neuron\Person\Parameters($storage);

		$post = $this->getPostParams();
		$arr = $cpar->listparam($post['param_ref_name']);
		$params = array();
		if ($arr) {
				foreach ($arr as $data) {
						array_push($params, $data);
				}
		}
		// menyebabkan session expired
		// echo json_encode(array('success' => true, 'list' => $params));
		// return $this->getResponse();
		
		return $this->getOutput(json_encode(array('success' => true, 'list' => $params)));
	}

	public function listParamAction($value='')
	{
		$storage = \Neuron\Person\Parameter\Storage::factory($this->getDb(), $this->getConfig());
		$cpar = new \Neuron\Person\Parameters($storage);

		$post = $this->getPostParams();

		$page = $post['start'];
	  	$rowCount = $post['length'];
	  	$filter['searchValue'] = $post['search']['value'];
	  	$order  = array('by' => $post['columns'][$post['order'][0]['column']]['data'], 'value'=>$post['order'][0]['dir']);
	  	$result = $cpar->lists($post['start'], $post['length'], $filter, $order);
	  	$output = array(
	        'draw' => $post['draw'],
	        'recordsFiltered' => intval($result['total']),
	        'recordsTotal' => intval($result['total']),
	        'data' => $result['rows']);

	  	$json = json_encode($output);
  		$response = $this->getResponse();
        $response->getHeaders()->addHeaderLine('Content-Type', 'application/json');
        $response->setContent($json);
        return $response;
	}

	public function loadAction() {
		$storage = \Neuron\Person\Parameter\Storage::factory($this->getDb(), $this->getConfig());
		$cpar = new \Neuron\Person\Parameters($storage);

		$post = $this->getPostParams();
		if (!$cpar->load($post['param_id']))  {
			echo json_encode(array('success' => false, 'data' => array()));
			return $this->getResponse();
		}

		$meddata = $cpar->pull();

		echo json_encode(array('success' => true, 'data' => $meddata));
		return $this->getResponse();
	}

	public function saveAction() {
		$storage = \Neuron\Person\Parameter\Storage::factory($this->getDb(), $this->getConfig());
		$cpar = new \Neuron\Person\Parameters($storage);
		$post = $this->getPostParams();

		if(empty($post['end_date'])){
			$post['end_date'] = null;
		}
		if (!empty($post['param_id'])) {
			$update = true;
			$cpar->load($post['param_id']);
			if($post['param_ref_id'] != $cpar->param_ref_id){
				$exist = $cpar->loadBY(array('param_ref_name'=> $post['param_ref_name'], 'param_ref_id'=> $post['param_ref_id']));
				if($exist){
					echo json_encode(array('success' => false, 'message'=>$this->translate('Ref id already exist')));
					return $this->getResponse();				
				}
			}
		} else {
			$post['param_id'] = null;
			$post['start_date'] = $storage->now();
			$update = false;
			$exist = $cpar->loadBY(array('param_ref_name'=> $post['param_ref_name'], 'param_ref_id'=> $post['param_ref_id']));
			if($exist){
				echo json_encode(array('success' => false, 'message'=>$this->translate('Ref id already exist')));
				return $this->getResponse();				
			}
		}
		
		$cpar = new \Neuron\Person\Parameters($storage, $post);
		$retval = $cpar->save($update);
		$success = false;
		$message = $this->translate('Error on save Parameter');
		if($retval){
			$success = true;
			$message = $this->translate('Success save parameter');
		}
		
		$requestPost = array(
			'guid' => '',
			'code' => '',
			'info' => '',
			'data' => $post
		); 

		$logparam['subject'] = 'PERSON SAVE PARAMETER';
		$logparam['identity'] = $this->getSession()->owner();;
		$logparam['data1'] = $retval;
		$logparam['description'] = 'Log proses person save parameter';
		$logparam['request'] = json_encode($requestPost);
		$logparam['response'] = json_encode(array('success' => $message, 'message'=> $message));

		$this->writeLogAction($logparam);
		
		echo json_encode(array('success' => $message, 'message'=> $message));
		return $this->getResponse();
	}

	public function terminateAction() {
		$storage = \Neuron\Person\Parameter\Storage::factory($this->getDb(), $this->getConfig());
		$cpar = new \Neuron\Person\Parameters($storage);

		$post = $this->getPostParams();

		if(isset($post['end_date'])){
			$post['end_date'] = date('Y-m-d', strtotime(($post['end_date'])));
		}else{
			$post['end_date'] = $storage->now();
		}

		$retval = $cpar->terminate($post);
		$success = false;
		$message = $this->translate('Error on terminate parameter');
		if ($retval){ 
			$success = true;
			$message = $this->translate('Success terminate parameter');
		}
		
		$requestPost = array(
			'guid' => '',
			'code' => '',
			'info' => '',
			'data' => $post
		); 

		$logparam['subject'] = 'PERSON TERMINATE PARAMETER';
		$logparam['identity'] = $this->getSession()->owner();;
		$logparam['data1'] = $retval;
		$logparam['description'] = 'Log proses person terminate parameter';
		$logparam['request'] = json_encode($requestPost);
		$logparam['response'] = json_encode(array('success' => $message, 'message'=> $message));
		
		$this->writeLogAction($logparam);
		
		echo json_encode(array('success' => $success, 'message'=>$message));
		return $this->getResponse();
	}

	public function deleteAction($value='')
	{
		$storage = \Neuron\Person\Parameter\Storage::factory($this->getDb(), $this->getConfig());
		$cpar = new \Neuron\Person\Parameters($storage);

		$post = $this->getPostParams();

		$retval = $cpar->delete($post['id']);
		$success = false;
		$message = $this->translate('Error on delete parameter');
		if ($retval){ 
			$success = true;
			$message = $this->translate('Success delete parameter');
		}
		
		$requestPost = array(
			'guid' => '',
			'code' => '',
			'info' => '',
			'data' => $post
		); 

		$logparam['subject'] = 'PERSON DELETE PARAMETER';
		$logparam['identity'] = $this->getSession()->owner();;
		$logparam['data1'] = $retval;
		$logparam['description'] = 'Log proses person delete parameter';
		$logparam['request'] = json_encode($requestPost);
		$logparam['response'] = json_encode(array('success' => $message, 'message'=> $message));
		
		$this->writeLogAction($logparam);
		
		echo json_encode(array('success' => $success, 'message'=>$message));
		return $this->getResponse();
	}

}

